diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/lte/model/epc-x2.cc ns-3.36/src/lte/model/epc-x2.cc
--- ns-3.35/src/lte/model/epc-x2.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/lte/model/epc-x2.cc	2022-04-30 18:23:57.926733700 -0700
@@ -56,24 +56,22 @@
 
 ///////////////////////////////////////////
 
-X2CellInfo::X2CellInfo (uint16_t localCellId, uint16_t remoteCellId)
+X2CellInfo::X2CellInfo (std::vector<uint16_t> localCellIds, std::vector<uint16_t> remoteCellIds) :
+  m_localCellIds {localCellIds},
+  m_remoteCellIds {remoteCellIds}
 {
-  m_localCellId = localCellId;
-  m_remoteCellId = remoteCellId;
 }
 
 X2CellInfo::~X2CellInfo (void)
 {
-  m_localCellId = 0;
-  m_remoteCellId = 0;
 }
 
 X2CellInfo& 
 X2CellInfo::operator= (const X2CellInfo& value)
 {
   NS_LOG_FUNCTION (this);
-  m_localCellId = value.m_localCellId;
-  m_remoteCellId = value.m_remoteCellId;
+  m_localCellIds = value.m_localCellIds;
+  m_remoteCellIds = value.m_remoteCellIds;
   return *this;
 }
 
@@ -130,8 +128,9 @@
 
 
 void
-EpcX2::AddX2Interface (uint16_t localCellId, Ipv4Address localX2Address, uint16_t remoteCellId, Ipv4Address remoteX2Address)
+EpcX2::AddX2Interface (uint16_t localCellId, Ipv4Address localX2Address, std::vector<uint16_t> remoteCellIds, Ipv4Address remoteX2Address)
 {
+  uint16_t remoteCellId = remoteCellIds.at (0);
   NS_LOG_FUNCTION (this << localCellId << localX2Address << remoteCellId << remoteX2Address);
 
   int retval;
@@ -151,18 +150,23 @@
   NS_ASSERT (retval == 0);
   localX2uSocket->SetRecvCallback (MakeCallback (&EpcX2::RecvFromX2uSocket, this));
 
+  std::vector<uint16_t> localCellIds;
+  localCellIds.push_back (localCellId);
 
   NS_ASSERT_MSG (m_x2InterfaceSockets.find (remoteCellId) == m_x2InterfaceSockets.end (),
                  "Mapping for remoteCellId = " << remoteCellId << " is already known");
-  m_x2InterfaceSockets [remoteCellId] = Create<X2IfaceInfo> (remoteX2Address, localX2cSocket, localX2uSocket);
+  for (uint16_t remoteCellId: remoteCellIds)
+    {
+      m_x2InterfaceSockets [remoteCellId] = Create<X2IfaceInfo> (remoteX2Address, localX2cSocket, localX2uSocket);
+    }
 
   NS_ASSERT_MSG (m_x2InterfaceCellIds.find (localX2cSocket) == m_x2InterfaceCellIds.end (),
                  "Mapping for control plane localSocket = " << localX2cSocket << " is already known");
-  m_x2InterfaceCellIds [localX2cSocket] = Create<X2CellInfo> (localCellId, remoteCellId);
+  m_x2InterfaceCellIds [localX2cSocket] = Create<X2CellInfo> (localCellIds, remoteCellIds);
 
   NS_ASSERT_MSG (m_x2InterfaceCellIds.find (localX2uSocket) == m_x2InterfaceCellIds.end (),
                  "Mapping for data plane localSocket = " << localX2uSocket << " is already known");
-  m_x2InterfaceCellIds [localX2uSocket] = Create<X2CellInfo> (localCellId, remoteCellId);
+  m_x2InterfaceCellIds [localX2uSocket] = Create<X2CellInfo> (localCellIds, remoteCellIds);
 }
 
 
@@ -201,7 +205,7 @@
           EpcX2SapUser::HandoverRequestParams params;
           params.oldEnbUeX2apId = x2HoReqHeader.GetOldEnbUeX2apId ();
           params.cause          = x2HoReqHeader.GetCause ();
-          params.sourceCellId   = cellsInfo->m_remoteCellId;
+          params.sourceCellId   = cellsInfo->m_remoteCellIds.at (0);
           params.targetCellId   = x2HoReqHeader.GetTargetCellId ();
           params.mmeUeS1apId    = x2HoReqHeader.GetMmeUeS1apId ();
           params.ueAggregateMaxBitRateDownlink = x2HoReqHeader.GetUeAggregateMaxBitRateDownlink ();
@@ -213,9 +217,7 @@
           NS_LOG_LOGIC ("sourceCellId = " << params.sourceCellId);
           NS_LOG_LOGIC ("targetCellId = " << params.targetCellId);
           NS_LOG_LOGIC ("mmeUeS1apId = " << params.mmeUeS1apId);
-          NS_LOG_LOGIC ("cellsInfo->m_localCellId = " << cellsInfo->m_localCellId);
-          NS_ASSERT_MSG (params.targetCellId == cellsInfo->m_localCellId,
-                         "TargetCellId mismatches with localCellId");
+          NS_LOG_LOGIC ("cellsInfo->m_localCellId = " << cellsInfo->m_localCellIds.at (0));
 
           m_x2SapUser->RecvHandoverRequest (params);
         }
@@ -231,8 +233,8 @@
           EpcX2SapUser::HandoverRequestAckParams params;          
           params.oldEnbUeX2apId = x2HoReqAckHeader.GetOldEnbUeX2apId ();
           params.newEnbUeX2apId = x2HoReqAckHeader.GetNewEnbUeX2apId ();
-          params.sourceCellId   = cellsInfo->m_localCellId;
-          params.targetCellId   = cellsInfo->m_remoteCellId;
+          params.sourceCellId   = cellsInfo->m_localCellIds.at (0);
+          params.targetCellId   = cellsInfo->m_remoteCellIds.at (0);
           params.admittedBearers = x2HoReqAckHeader.GetAdmittedBearers ();
           params.notAdmittedBearers = x2HoReqAckHeader.GetNotAdmittedBearers ();
           params.rrcContext     = packet;
@@ -255,8 +257,8 @@
 
           EpcX2SapUser::HandoverPreparationFailureParams params;          
           params.oldEnbUeX2apId = x2HoPrepFailHeader.GetOldEnbUeX2apId ();
-          params.sourceCellId   = cellsInfo->m_localCellId;
-          params.targetCellId   = cellsInfo->m_remoteCellId;
+          params.sourceCellId   = cellsInfo->m_localCellIds.at (0);
+          params.targetCellId   = cellsInfo->m_remoteCellIds.at (0);
           params.cause          = x2HoPrepFailHeader.GetCause ();
           params.criticalityDiagnostics = x2HoPrepFailHeader.GetCriticalityDiagnostics ();
 
@@ -302,8 +304,8 @@
             EpcX2SapUser::SnStatusTransferParams params;
             params.oldEnbUeX2apId = x2SnStatusXferHeader.GetOldEnbUeX2apId ();
             params.newEnbUeX2apId = x2SnStatusXferHeader.GetNewEnbUeX2apId ();
-            params.sourceCellId   = cellsInfo->m_remoteCellId;
-            params.targetCellId   = cellsInfo->m_localCellId;
+            params.sourceCellId   = cellsInfo->m_remoteCellIds.at (0);
+            params.targetCellId   = cellsInfo->m_localCellIds.at (0);
             params.erabsSubjectToStatusTransferList = x2SnStatusXferHeader.GetErabsSubjectToStatusTransferList ();
 
             NS_LOG_LOGIC ("oldEnbUeX2apId = " << params.oldEnbUeX2apId);
@@ -386,8 +388,8 @@
   NS_LOG_LOGIC ("GTP-U header: " << gtpu);
 
   EpcX2SapUser::UeDataParams params;
-  params.sourceCellId = cellsInfo->m_remoteCellId;
-  params.targetCellId = cellsInfo->m_localCellId;
+  params.sourceCellId = cellsInfo->m_remoteCellIds.at (0);
+  params.targetCellId = cellsInfo->m_localCellIds.at (0);
   params.gtpTeid = gtpu.GetTeid ();
   params.ueData = packet;
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/lte/model/epc-x2.h ns-3.36/src/lte/model/epc-x2.h
--- ns-3.35/src/lte/model/epc-x2.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/lte/model/epc-x2.h	2022-04-30 18:23:57.926733700 -0700
@@ -51,10 +51,10 @@
 
   /**
    * Assignment operator
-   *
+   * \param value value to assign
    * \returns X2IfaceInfo& 
    */
-  X2IfaceInfo& operator= (const X2IfaceInfo &);
+  X2IfaceInfo& operator= (const X2IfaceInfo &value);
 
 public:
   Ipv4Address   m_remoteIpAddr; ///< remote IP address
@@ -72,22 +72,22 @@
   /**
    * Constructor
    *
-   * \param localCellId local cell ID
-   * \param remoteCellId remote cell ID
+   * \param localCellIds local cell IDs
+   * \param remoteCellIds remote cell IDs
    */
-  X2CellInfo (uint16_t localCellId, uint16_t remoteCellId);
+  X2CellInfo (std::vector<uint16_t> localCellIds, std::vector<uint16_t> remoteCellIds);
   virtual ~X2CellInfo (void);
 
   /**
    * Assignment operator
-   *
+   * \param value value to assign
    * \returns X2CellInfo&  
    */
-  X2CellInfo& operator= (const X2CellInfo &);
+  X2CellInfo& operator= (const X2CellInfo &value);
 
 public:
-  uint16_t m_localCellId; ///< local cell ID
-  uint16_t m_remoteCellId; ///< remote cell ID
+  std::vector<uint16_t> m_localCellIds; ///< local cell IDs
+  std::vector<uint16_t> m_remoteCellIds; ///< remote cell IDs
 };
 
 
@@ -135,11 +135,11 @@
    * Add an X2 interface to this EPC X2 entity
    * \param enb1CellId the cell ID of the current eNodeB
    * \param enb1X2Address the address of the current eNodeB
-   * \param enb2CellId the cell ID of the neighbouring eNodeB
+   * \param enb2CellIds the cell IDs of the neighbouring eNodeB
    * \param enb2X2Address the address of the neighbouring eNodeB
    */
   void AddX2Interface (uint16_t enb1CellId, Ipv4Address enb1X2Address,
-                       uint16_t enb2CellId, Ipv4Address enb2X2Address);
+                       std::vector<uint16_t> enb2CellIds, Ipv4Address enb2X2Address);
 
 
   /** 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/lte/model/fdmt-ff-mac-scheduler.cc ns-3.36/src/lte/model/fdmt-ff-mac-scheduler.cc
--- ns-3.35/src/lte/model/fdmt-ff-mac-scheduler.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/lte/model/fdmt-ff-mac-scheduler.cc	2022-04-30 18:23:58.030734300 -0700
@@ -1041,14 +1041,12 @@
         {
           NS_LOG_INFO (this << " Layer " << (uint16_t)j << " CQI selected " << (uint16_t)worstCqi.at (j));
         }
-      uint32_t bytesTxed = 0;
       for (uint8_t j = 0; j < nLayer; j++)
         {
           newDci.m_mcs.push_back (m_amc->GetMcsFromCqi (worstCqi.at (j)));
           int tbSize = (m_amc->GetDlTbSizeFromMcs (newDci.m_mcs.at (j), RgbPerRnti * rbgSize) / 8); // (size of TB in bytes according to table 7.1.7.2.1-1 of 36.213)
           newDci.m_tbsSize.push_back (tbSize);
           NS_LOG_INFO (this << " Layer " << (uint16_t)j << " MCS selected" << m_amc->GetMcsFromCqi (worstCqi.at (j)));
-          bytesTxed += tbSize;
         }
 
       newDci.m_resAlloc = 0;  // only allocation type 0 at this stage
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/lte/model/fdtbfq-ff-mac-scheduler.cc ns-3.36/src/lte/model/fdtbfq-ff-mac-scheduler.cc
--- ns-3.35/src/lte/model/fdtbfq-ff-mac-scheduler.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/lte/model/fdtbfq-ff-mac-scheduler.cc	2022-04-30 18:23:58.030734300 -0700
@@ -1414,14 +1414,12 @@
         {
           NS_LOG_INFO (this << " Layer " << (uint16_t)j << " CQI selected " << (uint16_t)worstCqi.at (j));
         }
-      uint32_t bytesTxed = 0;
       for (uint8_t j = 0; j < nLayer; j++)
         {
           newDci.m_mcs.push_back (m_amc->GetMcsFromCqi (worstCqi.at (j)));
           int tbSize = (m_amc->GetDlTbSizeFromMcs (newDci.m_mcs.at (j), RgbPerRnti * rbgSize) / 8); // (size of TB in bytes according to table 7.1.7.2.1-1 of 36.213)
           newDci.m_tbsSize.push_back (tbSize);
           NS_LOG_INFO (this << " Layer " << (uint16_t)j << " MCS selected" << (uint16_t) m_amc->GetMcsFromCqi (worstCqi.at (j)));
-          bytesTxed += tbSize;
         }
 
       newDci.m_resAlloc = 0;  // only allocation type 0 at this stage
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/lte/model/lte-asn1-header.cc ns-3.36/src/lte/model/lte-asn1-header.cc
--- ns-3.35/src/lte/model/lte-asn1-header.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/lte/model/lte-asn1-header.cc	2022-04-30 18:23:58.034734200 -0700
@@ -309,7 +309,7 @@
     // Never extended attributes
     SerializeBoolean(false);
   }
-  
+
   // Clause 23.4 ITU-T X.691
   if (numOptions < 2)
     {
@@ -534,7 +534,7 @@
 {
   std::bitset<1> readBit;
   bIterator = DeserializeBitset<1> (&readBit,bIterator);
-  *value = (readBit[0] == 1) ? true : false;
+  *value = (readBit[0] == 1);
   return bIterator;
 }
 
@@ -584,15 +584,15 @@
       bIterator = DeserializeBitset<1> (&bitsRead1,bIterator);
       *n = (int)bitsRead1.to_ulong ();
       break;
-    case 2: 
+    case 2:
       bIterator = DeserializeBitset<2> (&bitsRead2,bIterator);
       *n = (int)bitsRead2.to_ulong ();
       break;
-    case 3: 
+    case 3:
       bIterator = DeserializeBitset<3> (&bitsRead3,bIterator);
       *n = (int)bitsRead3.to_ulong ();
       break;
-    case 4: 
+    case 4:
       bIterator = DeserializeBitset<4> (&bitsRead4,bIterator);
       *n = (int)bitsRead4.to_ulong ();
       break;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/lte/model/lte-asn1-header.h ns-3.36/src/lte/model/lte-asn1-header.h
--- ns-3.35/src/lte/model/lte-asn1-header.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/lte/model/lte-asn1-header.h	2022-04-30 18:23:58.034734200 -0700
@@ -329,13 +329,6 @@
    * \returns the modified buffer iterator
    */
   template <int N>
-  /**
-   * Deserialize a sequence
-   * \param optionalOrDefaultMask buffer to store the result
-   * \param isExtensionMarkerPresent true if Extension Marker is present
-   * \param bIterator buffer iterator
-   * \returns the modified buffer iterator
-   */
   Buffer::Iterator DeserializeSequence (std::bitset<N> *optionalOrDefaultMask,
                                         bool isExtensionMarkerPresent,
                                         Buffer::Iterator bIterator);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/lte/model/lte-enb-component-carrier-manager.h ns-3.36/src/lte/model/lte-enb-component-carrier-manager.h
--- ns-3.35/src/lte/model/lte-enb-component-carrier-manager.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/lte/model/lte-enb-component-carrier-manager.h	2022-04-30 18:23:58.038734400 -0700
@@ -165,10 +165,17 @@
    */
   virtual void DoReportUeMeas (uint16_t rnti, LteRrcSap::MeasResults measResults) = 0;
 
-  std::map <uint16_t, std::map<uint8_t, LteMacSapUser*> > m_ueAttached;//!< The map that contains the rnti, lcid, SAP of the RLC instance
-  std::map <uint16_t, std::map<uint8_t, LteEnbCmacSapProvider::LcInfo> > m_rlcLcInstantiated; //!< This map contains logical channel configuration per flow Id (rnti, lcid).
-  std::map <uint16_t, uint8_t> m_enabledComponentCarrier; //!< This map tells for each RNTI the number of enabled component carriers.
-  std::map <uint16_t, uint8_t> m_ueState; //!< Map of RRC states per UE (rnti, state), e.g. CONNECTED_NORMALLY
+  /**
+   * \brief Structure to represent UE info
+   */
+  struct UeInfo {
+    std::map<uint8_t, LteMacSapUser*> m_ueAttached; //!< Map from LCID to SAP of the RLC instance.
+    std::map<uint8_t, LteEnbCmacSapProvider::LcInfo> m_rlcLcInstantiated; //!< Logical channel configuration per flow Id (rnti, lcid).
+    uint8_t m_enabledComponentCarrier; //!< The number of enabled component carriers.
+    uint8_t m_ueState; //!< RRC states of UE, e.g. CONNECTED_NORMALLY
+  };
+
+  std::map <uint16_t, UeInfo> m_ueInfo; //!< The map from RNTI to UE information.
   uint16_t m_noOfComponentCarriers; //!< The number component of carriers that are supported by this eNb.
   // pointer to RRC object for direct function calls, e.g. when CCM needs to obtain
   // a pointer to RLC object of a specific flow
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/lte/model/lte-enb-mac.h ns-3.36/src/lte/model/lte-enb-mac.h
--- ns-3.35/src/lte/model/lte-enb-mac.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/lte/model/lte-enb-mac.h	2022-04-30 18:23:58.038734400 -0700
@@ -350,9 +350,8 @@
    *
    * Since SR is not implemented in LTE, this method does nothing.
    */
-  void DoReportSrToScheduler (uint16_t rnti)
+  void DoReportSrToScheduler ([[maybe_unused]] uint16_t rnti)
   {
-    NS_UNUSED (rnti);
   }
   
 public:
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/lte/model/lte-enb-net-device.cc ns-3.36/src/lte/model/lte-enb-net-device.cc
--- ns-3.35/src/lte/model/lte-enb-net-device.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/lte/model/lte-enb-net-device.cc	2022-04-30 18:23:58.038734400 -0700
@@ -226,17 +226,22 @@
   return m_cellId;
 }
 
-bool
-LteEnbNetDevice::HasCellId (uint16_t cellId) const
+std::vector<uint16_t>
+LteEnbNetDevice::GetCellIds () const
 {
+  std::vector<uint16_t> cellIds;
+
   for (auto &it: m_ccMap)
     {
-      if (it.second->GetCellId () == cellId)
-        {
-          return true;
-        }
+      cellIds.push_back (it.second->GetCellId ());
     }
-  return false;
+  return cellIds;
+}
+
+bool
+LteEnbNetDevice::HasCellId (uint16_t cellId) const
+{
+  return m_rrc->HasCellId (cellId);
 }
 
 uint16_t
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/lte/model/lte-enb-net-device.h ns-3.36/src/lte/model/lte-enb-net-device.h
--- ns-3.35/src/lte/model/lte-enb-net-device.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/lte/model/lte-enb-net-device.h	2022-04-30 18:23:58.038734400 -0700
@@ -108,6 +108,11 @@
   uint16_t GetCellId () const;
 
   /**
+   * \return the identifiers of cells served by this eNB
+   */
+  std::vector<uint16_t> GetCellIds () const;
+
+  /**
    * \param cellId cell ID
    * \return true if cellId is served by this eNB
    */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/lte/model/lte-enb-phy.h ns-3.36/src/lte/model/lte-enb-phy.h
--- ns-3.35/src/lte/model/lte-enb-phy.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/lte/model/lte-enb-phy.h	2022-04-30 18:23:58.038734400 -0700
@@ -274,8 +274,9 @@
 
   /**
    * \brief PhySpectrum received a new list of LteControlMessage
+   * \param msgList List of control messages
    */
-  virtual void ReceiveLteControlMessageList (std::list<Ptr<LteControlMessage> >);
+  virtual void ReceiveLteControlMessageList (std::list<Ptr<LteControlMessage> > msgList);
 
   // inherited from LtePhy
   virtual void GenerateCtrlCqiReport (const SpectrumValue& sinr);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/lte/model/lte-enb-phy-sap.h ns-3.36/src/lte/model/lte-enb-phy-sap.h
--- ns-3.35/src/lte/model/lte-enb-phy-sap.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/lte/model/lte-enb-phy-sap.h	2022-04-30 18:23:58.038734400 -0700
@@ -45,7 +45,6 @@
   /**
    * \brief Send the MAC PDU to the channel
    * \param p the MAC PDU to send
-   * \return true if
    */
   virtual void SendMacPdu (Ptr<Packet> p) = 0;
 
